import {
  ModalService, Modal, IModal, DialogService,
} from '@zeedhi/common';
import {
  Router, Http, IDictionary,
} from '@zeedhi/core';
// import { IQrCodeReaderEventParam } from '../components/qr-code-reader/common/IQrCodeReader';

export class QrCodeController {
  private qrCodeModal!: Modal;

  public decodeQrCode({ decodeString }: any) {
    const url = decodeString;

    const retornoFuncionario: IDictionary = [];

    const splitedUrl = url.split('/');

    let newPath = '';

    const userLogado = window.localStorage.getItem('UserLogado');

    const V = 'Detalhes_Vistoria';

    const T = 'Detalhes_Tarefa';

    for (let i = 3; i < splitedUrl.length; i += 1) {
      newPath += `/${splitedUrl[i]}`;
    }

    const NRLOCALCLIENTE = newPath.substr(1, 2);

    Http.post('/getAcesso', { userLogado }).then((response: IDictionary) => {
      retornoFuncionario.push(response.data.dataset.acesso);

      const perfil = response.data.dataset.acesso[0].NRPERFILACESSO;

      if (retornoFuncionario[0][0].IDDIRECIONAQRCODE === 'V') {
        Http.post('/getlocalUrl', { NRLOCALCLIENTE, userLogado, perfil }).then((retornoVistoria: IDictionary) => {
          const retornoArrayVistoria = retornoVistoria.data.dataset.local;

          if (retornoArrayVistoria.length !== 0) {
            const localCliente = retornoVistoria.data.dataset.local[0].NMLOCALCLIENTE;

            const localPai = retornoVistoria.data.dataset.local[0].NMLOCALPAI;

            let novaUrl = `${V}/${retornoVistoria.data.dataset.local[0].NRGERENCIAMENTOCHK}/${localCliente} | ${localPai}`;

            Router.replace(novaUrl);

            this.closeModal();

            novaUrl = '';
          } else {
            // Http.post('/getUrlLocaisNaoAlocados', { NRLOCALCLIENTE, userLogado, perfil }).then((retornoVistoriaNaoAlocada: IDictionary) => {
            //   if (retornoVistoriaNaoAlocada.length !== 0) {
            //     const localCliente = retornoVistoria.data.dataset.local[0].NMLOCALCLIENTE;

            //     const localPai = retornoVistoria.data.dataset.local[0].NMLOCALPAI;

            //     const novaUrl = `${V}/${retornoVistoria.data.dataset.local[0].NRGERENCIAMENTOCHK}/${localCliente} | ${localPai}`;

            //     Router.replace(novaUrl);

            //     this.closeModal();
            //   } else {

            //     this.closeModal();

            //     const texto = 'Não há Vistorias pendentes para o local escaneado';

            //     this.mensagem(texto);
            //   }
            // });
            this.closeModal();
            const texto = 'Não há Vistorias pendentes para o local escaneado';
            this.mensagem(texto);
          }
        });
      } else {
        Http.post('/getlocalUrl', { NRLOCALCLIENTE, userLogado, perfil }).then((retornoTarefa: IDictionary) => {
          const retornoArray = retornoTarefa.data.dataset.local;

          if (retornoArray.length !== 0) {
            let novaUrl = `${T}/${retornoTarefa.data.dataset.local[0].NRCHECKLISTAGEND}`;

            Router.replace(novaUrl);

            this.closeModal();

            novaUrl = '';
          } else {
            // Http.post('/getlocalUrl', { NRLOCALCLIENTE, userLogado, perfil }).then((retornoTarefaNaoAlocada: IDictionary) => {
            //   if (retornoTarefaNaoAlocada.length !== 0) {
            //     const novaUrl = `${T}/${retornoTarefa.data.dataset.local[0].NRCHECKLISTAGEND}`;

            //     Router.replace(novaUrl);

            //     this.closeModal();
            //   } else {
            //     this.closeModal();

            //     const texto = 'Não há tarefas pendentes para o local escaneado';

            //     this.mensagem(texto);
            //   }
            // });
            this.closeModal();
            const texto = 'Não há tarefas pendentes para o local escaneado';
            this.mensagem(texto);
          }
        });
      }
    });
  }

  public createModal() {
    const modal: IModal = {
      name: 'qrCodeModal',
      persistent: true,
      fullscreen: true,
      style: {
        background: '#black',
      },
      children: [
        {
          name: 'closeButtonHeader',
          component: 'ZdHeader',
          color: 'transparent',
          padless: true,
          elevation: 0,
          leftSlot: [
            {
              name: 'colTitleText',
              component: 'ZdCol',
              align: 'center',
              cols: 12,
              children: [
                {
                  name: 'titleText',
                  component: 'ZdText',
                  text: 'Escaneie o QR Code',
                  cssClass: 'text-center',
                  style: {
                    'margin-bottom': '15px',
                    'font-weight': 'bold',
                    'font-size': '20px',
                  },
                },
              ],
            },
          ],
          rightSlot: [
            {
              name: 'closeModalButton',
              component: 'ZdModalCloseButton',
              small: true,
              modalName: 'qrCodeModal',
            },
          ],
        },
        {
          name: 'rowQrCode',
          component: 'ZdRow',
          children: [
            {
              name: 'qrcode',
              component: 'QrCodeReader',
              events: {
                decode: this.decodeQrCode.bind(this),
              },
            },
          ],
        },
      ],
    };
    this.qrCodeModal = ModalService.create(modal);
  }

  public destroyModal() {
    this.qrCodeModal.destroy();
  }

  public openModal() {
    this.qrCodeModal.show();
  }

  public closeModal() {
    this.qrCodeModal.hide();
  }

  public mensagem(texto: string) {
    DialogService.show({
      name: 'basic-dialog',
      title: 'Atenção',
      text: `${texto}`,
      buttons: [
        {
          name: 'yes',
          component: 'ZdButton',
          label: 'Sair',
          events: {
            click: () => DialogService.hide(),
          },
        },
      ],
    });
  }
}
